''This is the user interface object... which supports the stereo-ts_mcp3208 object.  This is
''a dual prop setup... so we have a pair of objects.

''This is working beta code.  It is not the final iteration of code.  I'm  releasing it because, it demonstrates
''how to save sequential files to an SD in a named ordered set.  Each time the Prop reboots, it
''checks counts the number of files on the sd card...  creates a new file and writes all incoming data
''to that file, line by line.  Lines  are  512 words long...  256 pixels, with the first 128 belonging to the
''left sensor and the next 128 pixels to the right sensor.  Images can be opened and view using
''ImageJ, public domain software from NIH.  http://rsbweb.nih.gov/ij/.

''To open files  chose the import option in the files menu...then select "raw"... this opens
''a dialog, where you  select the 16 bit unsigned option at the top. Put 256 into the width and however many lines you want to view in
''the height box. Finally you check the "Little Endian Byte Order" box and you are good to go.
''I have opened images created in this way with over 3000 lines of data, acquired over night.

CON
  '' I/O SETTINGS

   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
  
   delayserial = 5
   video     = 20
   triggerout   = 12
   rxpin        = 10
   txpin        = 11
   triggerIN  = 13
   baud      = 115200
   
obj

  tv: "tv_wtext"
  io: "fullDuplexSerial"
  sdfat: "fsrw"

VAR

  long stack[100]
  long ok,sumdiffl,sumpixelindexL,sumdiffr,sumpixelindexR,Lpixel_Loc,Rpixel_Loc,docorr
  word iod [256]
  word maxR,maxL,maxL_loc ,maxR_loc
  word i,done
  byte title [8]
  byte tbuf[256] 
PUB start  |  r,a,x,line,t1,temp,numfiles,temp2
  waitcnt(clkfreq/3 + cnt)    
  io.start(10,11,0,115200)   
  tv.start(video)

  tv.str(string("Processing ... sd card?...."))
  tv.out(13)
  sdfat.mount(0)
  numfiles:=0
 
  sdfat.opendir 
  repeat while 0 == sdfat.nextfile(@tbuf)
      numfiles++
  temp2:=numfiles
  title[0]:=t 
  title[1]:=t-1
  title[2]:=t-8 
  title[3]:="_"
  title[4]:=num  + (numfiles/100)
  numfiles:=numfiles//100
  title[5]:=num + (numfiles/10)
  title[6]:=num+ (numfiles//10)
  r := sdfat.popen(@title, "w")     'essentially empties camfile2 if it already exists
  sdfat.pclose
  x:=cognew(io2SD,@stack)
  waitcnt(clkfreq/3 + cnt)
  dira[triggerout]:=1
  repeat 10
    t1:=cnt
  
    repeat line from  0 to 129
        ok:=false
        outa[triggerOut]:=1
        repeat until ina[triggerIn]== 1
        outa[triggerOut]:=0
        repeat until ina[triggerin]==0       'tsl unit done sending
        'temp:=find_corresponding_pixels
        tv.str(string("line="))
        tv.dec(line)
        tv.str(string("   "))
    
Pub find_corresponding_pixels  | testpixel ,wtdiff,wtdiff_r,j,testpixel_r,noisefloor_l,noisefloor_r
    sumdiffL:=0
    sumdiffR:=0
    wtdiff:=0
    getmax
    noisefloor_L:=(maxL * 3)/4
    noisefloor_R:=(maxR *3)/4
    sumpixelindexL:=0
    sumpixelindexR:=0
    wtdiff_r:=0
    repeat  j from 0 to 127
       testpixel := iod[j]
       testpixel_r:=iod[j+128]
       if testpixel > noisefloor_l
            wtdiff:=wtdiff + (testpixel*j)
            sumdiffl:=sumdiffl+testpixel
            sumpixelindexL:=sumpixelindexL + j          
       if testpixel_r > noisefloor_r
            wtdiff_r:=wtdiff_r + (testpixel_r*(j+128))
            sumdiffr:=sumdiffr+testpixel_r
            sumpixelindexr:=sumpixelindexr + (j+128)


    Rpixel_loc:=wtdiff_r/sumdiffR      
    Lpixel_loc:= wtdiff/sumdiffl
    tv.str(string(" Left pixel = "))
    tv.dec(lpixel_loc)
    tv.str(string("  maxLval= "))
    tv.dec(maxL)
    tv.str(string(",lmax loc =" ))
    tv.dec(maxL_loc)
    tv.out(13)
    tv.str(string(" R pixel = "))
    tv.dec(rpixel_loc)
    tv.str(string("  maxRval= "))
    tv.dec(maxr)
    tv.str(string("  Rmax loc =" ))
    tv.dec(maxr_loc)
    tv.out(13)
Pub GetMax    | j
    maxL:=0
    maxR:=0
    repeat  j from 0 to 127
       if iod[j]  > maxL
          maxL:=iod[j]
          maxL_loc:=j
       if iod[j+128]  > MaxR
          maxR:=iod[j+128]
          maxR_loc:=j+128
Pub IO2SD | r
  i:=0
  dira[triggerout]:=1
  repeat
    'repeat until ina[triggerIn]== 1
 
    iod.byte[i]:=io.rx
    i++
    if i == 512
      'outa[delayserial]:=1
       r:=sdfat.popen(@title,"a")
       sdfat.pwrite(@iod,512)
       sdfat.pclose
       outa[triggerout]:=0
       'repeat while ina[triggerIn] == 1
       i:=0
       ok:=true
DAT
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0
t                   byte  "T",0